/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package io.vertx.rxjava.it.service;

import rx.Observable;
import rx.Single;
import io.vertx.rx.java.RxHelper;
import io.vertx.rx.java.WriteStreamSubscriber;
import io.vertx.rx.java.SingleOnSubscribeAdapter;
import java.util.Map;
import java.util.Set;
import java.util.List;
import java.util.Iterator;
import java.util.function.Function;
import java.util.stream.Collectors;
import io.vertx.core.Handler;
import io.vertx.core.AsyncResult;
import io.vertx.core.json.JsonObject;
import io.vertx.core.json.JsonArray;
import io.vertx.lang.rx.RxGen;
import io.vertx.lang.rx.TypeArg;
import io.vertx.lang.rx.MappingIterator;

/**
 *
 * <p/>
 * NOTE: This class has been automatically generated from the {@link io.vertx.it.service.HelloService original} non RX-ified interface using Vert.x codegen.
 */

@RxGen(io.vertx.it.service.HelloService.class)
public class HelloService {

  @Override
  public String toString() {
    return delegate.toString();
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    HelloService that = (HelloService) o;
    return delegate.equals(that.delegate);
  }
  
  @Override
  public int hashCode() {
    return delegate.hashCode();
  }

  public static final TypeArg<HelloService> __TYPE_ARG = new TypeArg<>(    obj -> new HelloService((io.vertx.it.service.HelloService) obj),
    HelloService::getDelegate
  );

  private final io.vertx.it.service.HelloService delegate;
  
  public HelloService(io.vertx.it.service.HelloService delegate) {
    this.delegate = delegate;
  }

  public HelloService(Object delegate) {
    this.delegate = (io.vertx.it.service.HelloService)delegate;
  }

  public io.vertx.it.service.HelloService getDelegate() {
    return delegate;
  }

  public void hello(JsonObject name, Handler<AsyncResult<String>> resultHandler) { 
    delegate.hello(name, resultHandler);
  }

    public Single<String> rxHello(JsonObject name) { 
    return Single.create(new io.vertx.rx.java.SingleOnSubscribeAdapter<>(fut -> {
      hello(name, fut);
    }));
  }

  public static HelloService newInstance(io.vertx.it.service.HelloService arg) {
    return arg != null ? new HelloService(arg) : null;
  }

}
